%% Identify Lab instruments

%% Query for hardware information

gh = instrhwinfo('gpib','agilent');
disp(gh);

%% Query individual instruments

n = length(gh.ObjectConstructorName);
for (k=1:n)
    str = char(gh.ObjectConstructorName(k));
    obj = eval(str);
    fopen(obj);
    fprintf(obj,'*IDN?');
    idn = fscanf(obj);
    fprintf('\ninterface: %s\n',str);
    fprintf('identification: %s\n',idn);
    fclose(obj);
    delete(obj);
    clear obj;
end

%% Open function generator and scope

fg = gpib('agilent',7,10);
os = gpib('agilent',7,7);
fopen(fg)
fopen(os)

%% Configure the function generator

fprintf(fg,'APPLY:TRIANGLE 1500, 1');
fprintf(fg,'APPLY?');
query = fscanf(fg);
disp(query);

%% Configure the oscilloscope

fprintf(os,':AUTOSCALE')
fprintf(os,':MEASURE:FREQ');
fprintf(os,':MEASURE:VRMS');
fprintf(os,':MEASURE:VPP');
fprintf(os,':MEAS:FREQ?');
freq = fscanf(os,'%g');
fprintf('frequency: %g Hz\n',freq);
fprintf(os,':MEAS:VPP?');
vpp = fscanf(os,'%g');
fprintf('vpp: %g V\n',vpp);
fprintf(os,':MEAS:VRMS?');
vrms = fscanf(os,'%g');
fprintf('vrms: %g V\n',vrms);

%% Close all instruments

g = instrfind;
for k=1:length(g)
    fclose(g(k));
    delete(g(k));
end
clear g;